' @(#)85    1.2  src/hc/client/collectors/C/vbs/adminpassprop.vbs, hc.collectors.win, scmweb, 101014a  10/7/10  08:13:21
'
' IBM Security Compliance Manager
' 5724-F82
' (C) IBM, 2006.
' All Rights Reserved
' Licensed Materials - Property of IBM
'
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' This script prints administrator password properties. Specifically,        '
'  it displays information whether:                                          '
'  * simple passwords are allowed or it is required to provide a complex one '
'  * is it possible to lockout administrator account                         '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit
On Error Resume Next

Const ROLE_STANDALONE_WST = 0
Const ROLE_MEMBER_WST     = 1
Const ROLE_STANDALONE_SVR = 2
Const ROLE_MEMBER_SVR     = 3
Const ROLE_BACKUP_DC      = 4
Const ROLE_PRIMARY_DC     = 5

Dim passPropHash
Dim wmiService
Dim compList
Dim computer
Dim computerRole
Dim pwdProp

Set passPropHash = CreateObject("Scripting.Dictionary")
passPropHash.Add "DOMAIN_PASSWORD_COMPLEX", &h1
passPropHash.Add "DOMAIN_LOCKOUT_ADMINS",   &h8

Set wmiService = GetObject("winmgmts:\\.\root\cimv2")
Set compList = wmiService.ExecQuery("Select DomainRole, Name, Domain from Win32_ComputerSystem")
For Each computer in compList
	computerRole = computer.DomainRole
Next
	pwdProp =  GetAdminPassPropOnActiveDirectory
	If ((Err.number = 0) AND (NOT IsNull(pwdProp)) )Then
		PrintOut(pwdProp)
	Else
		Err.clear
		WScript.StdErr.Write "[Error] When running script." & Err.number & Err.Description
		WScript.Quit(-1)
	End If

WScript.Quit(0)

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function GetAdminPassPropOnActiveDirectory
	Dim objRootDSE
	Dim hostname
	Dim objDomain
	Dim intPwdProperties
	
	Set objRootDSE = GetObject("LDAP://rootDSE")

	If IsNull(objRootDSE) Then
		WScript.StdErr.Write "[Error] RootDSE cannot be contacted"
		WScript.Quit(-1)
	End If

	'hostName = objRootDSE.get("dnsHostName")
	'Set objDomain = GetObject("LDAP://" & hostName)
	
	Set objDomain = GetObject("LDAP://" & objRootDSE.Get("defaultNamingContext") )
	
	If IsNull(objDomain) Then
		WScript.StdErr.Write "[Error] LDAP://" & hostName & " cannot be contacted"
		WScript.Quit(-1)
	End If

	' Read pwdProperties
	intPwdProperties = -9999
	intPwdProperties = objDomain.Get("PwdProperties")
	if intPwdProperties = -9999 Then
		WScript.StdErr.Write "[Error] Couldn't get password properties"
		WSCript.Quit(-1)
	End If

	GetAdminPassPropOnActiveDirectory = intPwdProperties

End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub PrintOut(pwdProperties)
	Dim key
	
	WScript.Echo "[AdminPasswordProperties]"

	For Each Key In passPropHash.Keys
		If passPropHash(Key) And pwdProperties Then
			WScript.Echo Key & "=1"
		Else
			WScript.Echo Key & "=0"
		End If
	Next

End Sub

