' @(#)75    1.3  src/hc/client/collectors/C/vbs/anonftpiis.vbs, hc.collectors.win, scmweb, 110401a  3/31/11  09:26:32   
' IBM Security Compliance Manager
' 5724-F82                       
' (C) IBM, 2006.                 
' All Rights Reserved            
' Licensed Materials - Property of IBM 
'
' US Government Users Restricted Rights - Use, duplication or 
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.


'*****************************************************
' Variables
'*****************************************************
Dim Args(999) ' Array that contains all of the non-global arguments
Dim ArgCount ' Tracks the size of the Args array
Args(0) = "ENUMALL"
Args(1) = "MSFTPSVC"
' Used for string formatting
Dim AllowAnonymous
AllowAnonymous = false


'*****************************************************


'*****************************************************
' Main Script Code
' check if IIS is installed and if it is what version is installed <=6 or >6. 
' This will help in getting information about ftp in different ways
'*****************************************************
Select Case GetIISversion()
    Case "<=6"
        Results = EnumCommand(True, "")
		WScript.Quit(0)
    Case ">6"
		EnumIIS7FtpPaths()
		WScript.Quit(0)
    Case Else
        WScript.Echo "Error=ERROR(432): " & "Unknown IIS version!?"
	WScript.Quit(-1)
End Select
'*****************************************************



'*****************************************************
' Function that check if IIS is installed, and if it is returns range version <=6 or >6 . 
' Version need to be known to get FTP paths in different ways.
'*****************************************************
Function GetIISversion()
    On Error Resume Next
    strComputer = "."
    	
	Set objIIS6 = GetObject("IIS://localhost/MSFTPSVC")

	If Err.Number <> 0 Then
		'WScript.Echo IsEmpty(Err.Source)
		If Err.Source <> "" Then
			WScript.Echo "Error=ERROR(423): " & Err.Description&  ". Permission denied to read WMI object IIS://localhost/MSFTPSVC . Script must be run as Administrator."
			WScript.Quit(-1)
		End If
	End If

    Set objWMIService = GetObject("winmgmts:{impersonationlevel=impersonate}!\\" & strComputer & "\root\MicrosoftIISv2")
	
    If IsEmpty(objWMIService) and IsEmpty(objIIS6) Then
		
		WScript.Echo "Error=ERROR(424): " & "Microsoft IIS is not installed or FTP service is not installed."
		WScript.Quit (-1) 
    Else
	If IsEmpty(objIIS6) Then
	    	Set colItems = objWMIService.ExecQuery("Select * from IIsWebInfo")
		If IsEmpty(colItems) Then
			WScript.Echo "Error=ERROR(425): " & "FTP is not installed."
			WScript.Quit (-1)
		End If
	    	For Each objItem in colItems
			If (objItem.MajorIIsVersionNumber > 6) Then
				GetIISversion = ">6"
			Else
				GetIISversion = "unknown"
			End If
		Next
	Else
		GetIISversion = "<=6"
	End If
    End If

End Function
'*****************************************************



'*****************************************************
' Function that enumerates all PATHs setted to all FTP sites 
' that have AnonymousAuth setted to TRUE.
' This Function works ONLY for IIS 7 and 7.5
'*****************************************************
Function EnumIIS7FtpPaths()
On Error Resume Next
Set IISOBJ = GetObject("IIS://LocalHost/W3SVC")
Set adminManager = createObject("Microsoft.ApplicationHost.WritableAdminManager")
adminManager.CommitPath = "MACHINE/WEBROOT/APPHOST"
'Set sitesSection = adminManager.GetAdminSection("system.applicationHost/sites", "MACHINE/WEBROOT/APPHOST")
Set sitesSection = adminManager.GetAdminSection("system.applicationHost/sites", adminManager.CommitPath)
Set sitesCollection = sitesSection.Collection


strComputer = "." 
Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\MicrosoftIISv2")


For Each Web In IISOBJ

If (Web.Class = "IIsWebServer") Then

   ValueList = Web.Get("ServerBindings")
  
  ' check for ServerBiding. For FTP UBound(ValueList) is -1 and for WEBSites is 0
  if(UBound(ValueList) <> 0) Then
     set IIsWebVirtualDirSettingObj = objWMIService.get("IIsWebVirtualDirSetting='W3SVC/" + Web.Name + "/ROOT'")
   
	IF IsEmpty(IIsWebVirtualDirSettingObj) Then
		WScript.Echo "Error=ERROR(431): " & "Cannot get IIsWebVirtualDirSetting object"
		WScript.Quit (-1) 
	END IF
     siteElementPos = FindElement(sitesCollection, "site", Array("name", Web.Servercomment))
     Set siteElement = sitesCollection.Item(siteElementPos)
	
     Set ftpServerElement = siteElement.ChildElements.Item("ftpServer")
     Set securityElement = ftpServerElement.ChildElements.Item("security")
     Set authenticationElement = securityElement.ChildElements.Item("authentication")
     Set anonymousAuthenticationElement = authenticationElement.ChildElements.Item("anonymousAuthentication")
     'WScript.Echo anonymousAuthenticationElement.Properties.Item("enabled").Value

     For Each Property in IIsWebVirtualDirSettingObj.Properties_ 
		IF(Property.Name = "Path" AND anonymousAuthenticationElement.Properties.Item("enabled").Value <> 0) Then
			WScript.Echo Property.Name & "=" & Property.Value 
			Exit For
		END IF
    Next
   End If
  
 End If

Next

End Function
'*****************************************************



'*****************************************************
' Function that find element in a colection, by Name or valueToMach
'*****************************************************
Function FindElement(collection, elementTagName, valuesToMatch)
   For i = 0 To CInt(collection.Count) - 1
      Set element = collection.Item(i)
      If element.Name = elementTagName Then
         matches = True
         For iVal = 0 To UBound(valuesToMatch) Step 2
            Set property = element.GetPropertyByName(valuesToMatch(iVal))
            value = property.Value
            If Not IsNull(value) Then
               value = CStr(value)
            End If
            If Not value = CStr(valuesToMatch(iVal + 1)) Then
               matches = False
               Exit For
            End If
         Next
         If matches Then
            Exit For
         End If
      End If
   Next
   If matches Then
      FindElement = i
   Else
      FindElement = -1
   End If
End Function
'*****************************************************



'*****************************************************
' Function that enumerates all PATHs setted to all FTP sites 
' that have AnonymousAuth setted to TRUE.
' This Function works ONLY for IIS 6 or versions less then 6
'*****************************************************
Function EnumCommand(Recurse, StartPath)

    On Error Resume Next

    Dim IIsObject
    Dim IIsObjectPath
    Dim IIsSchemaObject
    Dim IIsSchemaPath
    Dim ObjectPath
    Dim MachineName
    Dim ValueIndex
    Dim ValueList
    Dim ValueListArray
    Dim ValueString
    Dim PropertyName
    Dim PropertyAttribObj
    Dim PropertyListSet
    Dim PropertyList
    Dim PropertyObjPath
    Dim PropertyObject
    Dim ChildObject
    Dim ChildObjectName
    Dim EnumPathsOnly
    Dim EnumAllData
    Dim ErrMask
    Dim IsInherit

    Dim PropertyDataType

    Dim SpecialResult

    Dim PathOnlyOption
    PathOnlyOption = "/P"
	
	EnumCommand = 0 ' Assume Success
    EnumPathsOnly = False ' Assume that the user wants all of the data items
    EnumAllData = False ' Assume that the user wants only the actual data items
    ObjectPath = Args(1)

    If StartPath <> "" Then ObjectPath = StartPath

    SanitizePath ObjectPath
    MachineName = "localhost"

    IIsObjectPath = "IIS://" & MachineName
    If (ObjectPath <> "") Then
        IIsObjectPath = IIsObjectPath & "/" & ObjectPath
    End If

    Set IIsObject = GetObject(IIsObjectPath)

	If (Err.Number <> 0) Then
        WScript.Echo "Error=ERROR(425): " & "IIS is installed but FTP is not."
        WScript.Quit (-1)
    End If

    ' Get the Schema of the object and enumerate through all of the properties
    IIsSchemaPath = IIsObject.Schema
    Set IIsSchemaObject = GetObject(IIsSchemaPath)

    If (Err.Number <> 0) Then
        WScript.Echo "Error=ERROR(426): " & "Error Trying To GET the Schema of the class: " & IIsSchemaPath
        WScript.Quit (Err.Number)
    End If

    ReDim PropertyListSet(1)
    PropertyListSet(0) = IIsSchemaObject.MandatoryProperties
    PropertyListSet(1) = IIsSchemaObject.OptionalProperties

    If (Err.Number <> 0) Then
        WScript.Echo "Error=ERROR(427): " & "Error trying to get the list of properties: " & IIsSchemaPath
        WScript.Quit (Err.Number)
    End If


    If (Not EnumPathsOnly) Then
        For Each PropertyList In PropertyListSet

            For Each PropertyName In PropertyList
                If Err <> 0 Then
                    Exit For
                End If

                ' Test to see if the property is even set at this node
                IsInherit = False
                Err.Clear
                Set PropertyAttribObj = IIsObject.GetPropertyAttribObj(PropertyName)
                If (Err.Number = 0) Then

                    If (PropertyAttribObj.IsInherit) Then
                        IsInherit = True
                    End If
                    Err.Clear

                    If (IsInherit = False) Or (EnumAllData) Then
                    ' If the above statement is true, then the data exists here or the user wants it anyway.

                        PropertyObjPath = "IIS://" & MachineName & "/Schema/" & PropertyName
                        Set PropertyObject = GetObject(PropertyObjPath)

                        If (Err.Number <> 0) Then
                            WScript.Echo "Error=ERROR(428): " &  "Error trying to enumerate the Optional properties (Couldn't Get Property Information): " & PropertyObjPath
                            WScript.Quit (-1)
                            EnumCommand = Err.Number
                            Err.Clear
                        End If

                        ValueList = ""
                        ValueListArray = ""

                        PropertyDataType = UCase(PropertyObject.Syntax)
                        Select Case PropertyDataType
                        Case "STRING"
							If(PropertyName = "Path") Then
								If(AllowAnonymous = True) Then
									ValueList = IIsObject.Get(PropertyName)
									WScript.Echo PropertyName & "=" & ValueList
								End If
							End If
                        Case "BOOLEAN"
                            ValueList = IIsObject.Get(PropertyName)
							'WScript.Echo PropertyName & "=" & ValueList
							If(PropertyName = "AllowAnonymous") Then
									AllowAnonymous = ValueList
									'WScript.Echo PropertyName & "=" & ValueList
							End If
						End Select

                    End If ' End if data exists at the current node

                Else ' Error during GetPropertyAttribObj
                    Err.Clear 'ignore and go to the next property
                End If

                If (Err.Number <> 0) Then
                    ' If there is an ADS error, just ignore it and move on
                    ' otherwise, quit
                    If ((Err.Number) >= &H80005000) And ((Err.Number) < &H80006000) Then
                        Err.Clear
                    Else
                    	WScript.Echo "Error=ERROR(428): " & "Error trying to enumerate the Optional properties (Error trying to get property value): " & PropertyObjPath
                        WScript.Quit (-1)
                    End If
                    WScript.Echo
                End If
            Next
        Next

        If (Err.Number <> 0) Then
            'WScript.Echo "Error=ERROR(" & Err.Number & "): " &  "Error trying to enumerate the properties lists:"
            EnumCommand = Err.Number
            Err.Clear
        End If

    End If ' End if (Not EnumPathsOnly)

    'WScript.Echo "Last Error: " & Err & " (" & Hex (Err) & "): " & Err.Description
    ' Now, enumerate the data paths
    For Each ChildObject In IIsObject
        If (Err.Number <> 0) Then Exit For

        ChildObjectName = Right(ChildObject.AdsPath, Len(ChildObject.AdsPath) - 6)
        ChildObjectName = Right(ChildObjectName, Len(ChildObjectName) - InStr(ChildObjectName, "/") + 1)
        'WScript.Echo "[" & ChildObjectName & "]"
        If (Recurse = True) And (ChildObjectName <> Args(1)) Then
            EnumCommand = EnumCommand(True, ChildObjectName)
        End If
    Next

    If (Err.Number <> 0) Then
        'WScript.Echo "Error=ERROR(" & Err.Number & "): " & WScript.Echo "Error trying to enumerate the child nodes"
        EnumCommand = Err.Number
        Err.Clear
    End If
End Function
'*****************************************************



'*****************************************************
' Used for modified path object. Don't ask for more ..
'*****************************************************
Sub SanitizePath(ObjectPath)
    On Error Resume Next

    ' Remove WhiteSpace
    Do While (Left(ObjectPath, 1) = " ")
        ObjectPath = Right(ObjectPath, Len(ObjectPath) - 1)
    Loop

    Do While (Right(ObjectPath, 1) = " ")
        ObjectPath = Left(ObjectPath, Len(ObjectPath) - 1)
    Loop

    ' Replace all occurrences of \ with /
    ObjectPath = Replace(ObjectPath, "\", "/")

    ' Remove leading and trailing slashes
    If Left(ObjectPath, 1) = "/" Then
        ObjectPath = Right(ObjectPath, Len(ObjectPath) - 1)
    End If

    If Right(ObjectPath, 1) = "/" Then
        ObjectPath = Left(ObjectPath, Len(ObjectPath) - 1)
    End If

    If (Err.Number <> 0) Then
        ' ReportError ()
		WScript.Echo "Error=ERROR(429): " & "Error Trying To Sanitize the path: " & ObjectPath
		WScript.Quit (-1)
    End If

End Sub
'*****************************************************



'*****************************************************
' Checks to see if the property requires special processing in order to
' display its contents.
'*****************************************************
Function IsSecureProperty(ObjectParameter,MachineName)

    On Error Resume Next
    Dim PropObj,Attribute
    Set PropObj = GetObject("IIS://" & MachineName & "/schema/" & ObjectParameter)
    If (Err.Number <> 0) Then
        'ReportError ()
        WScript.Echo "Error=ERROR(430): " & "Error trying to get the property: " & err.number
		WScript.Quit (-1)
    End If
    Attribute = PropObj.Secure
    If (Attribute = True) Then
        IsSecureProperty = True
    Else
        IsSecureProperty = False
    End If
End Function
'*****************************************************